#include "SettingsParser.hpp"
#include "Core/Log.hpp"

#include <fstream>

namespace airsim_client {

	SettingsParser::SettingsParser() {
		using namespace msr::airlib;

		std::string file_path = Settings::Settings::getUserDirectoryFullPath("settings.json");
		std::ifstream ifs(file_path);

		if (!ifs.good()) {
			CLIENT_FATAL("Could not read settings file")
		}

		std::stringstream ss;
		ss << ifs.rdbuf();
		std::string settings_txt = ss.str();

		AirSimSettings::initializeSettings(settings_txt);

		AirSimSettings::singleton().load([]() {
			CLIENT_WARN("Could not find Simmode setting. Choosing Multirotor")
			return "Multirotor";
		});
	}
} // namespace airsim_client
