#ifndef AIRSIM_CLIENT_CLIENT_EVENT
#define AIRSIM_CLIENT_CLIENT_EVENT
#include "Core/Event.hpp"
#include "Core/Node.hpp"
#include <sstream>

namespace airsim_client { namespace core {

	class ShutdownEvent : public Event {
	public:
		EVENT_CLASS_CATEGORY(EventCategoryClient)
		EVENT_CLASS_TYPE(EventType::Shutdown)
	};

	class WindowCloseEvent : public Event {
	public:
		EVENT_CLASS_CATEGORY(EventCategoryClient)
		EVENT_CLASS_TYPE(EventType::WindowClose)
	};

	class WindowResizeEvent : public Event {
	public:
		EVENT_CLASS_CATEGORY(EventCategoryClient)
		EVENT_CLASS_TYPE(EventType::WindowResize)

		WindowResizeEvent(int width, int height)
			: width_{width}, height_{height} {}

		inline int GetWidth() { return width_; }
		inline int GetHeight() { return height_; }

	private:
		int width_, height_;
	};

}} //namespace airsim_client::core
#endif //AIRSIM_CLIENT_EVENT
