#ifndef AIRSIM_CLINET_DATA_TRANSFER_EVENT
#define AIRSIM_CLINET_DATA_TRANSFER_EVENT

#include "Core/Event.hpp"

#include <tuple>
#include <vector>

namespace airsim_client { namespace core {

	template <typename... DataTypes>
	class DataTransferEvent : public Event {
	public:
		EVENT_CLASS_TYPE(EventType::DataTransfer)
		EVENT_CLASS_CATEGORY(EventCategoryDataTransfer)

		explicit DataTransferEvent(DataTypes... data)
			: data_{std::make_tuple(std::make_shared<DataTypes>(std::move(data))...)} {}
	
	protected:
		std::tuple<std::shared_ptr<DataTypes>...> data_;
	};

}} // namespace airsim_client::core
#endif // AIRSIM_CLINET_DATA_TRANSFER_EVENT
