#include "Log.hpp"
#include <spdlog/sinks/stdout_color_sinks.h>
#include <spdlog/sinks/basic_file_sink.h>

namespace airsim_client { namespace core {

	std::shared_ptr<spdlog::logger> Log::logger_;
	std::shared_ptr<spdlog::logger> Log::file_logger_;

void Log::Init() {

	logger_ = spdlog::stdout_color_mt("CLIENT");
	logger_->set_pattern("%^[%T] %n: %v%$");

	file_logger_ = spdlog::basic_logger_mt("CLIENT_F", "/home/schwung/catkin_ws/src/MasterThesis/Client/logs/log.txt");
	file_logger_->set_pattern("%v");

	#ifdef AIRSIM_CLIENT_DEBUG
	logger_->set_level(spdlog::level::debug);
	file_logger_->set_level(spdlog::level::debug);
	#else
	logger_->set_level(spdlog::level::info);
	file_logger_->set_level(spdlog::level::info);
	#endif
}

} // namespace core
} // namespace airsim_client
