#ifndef AIRSIM_CLIENT_ROS_EVENT
#define AIRSIM_CLIENT_ROS_EVENT
#include "Core/Event.hpp"
#include "Core/Events/DataTransferEvent.hpp"
#include "AirSimTools/CommonTypes.hpp"

#include <tf2_geometry_msgs/tf2_geometry_msgs.h>

namespace airsim_client {

	template <typename GT, typename ET> class GroundTruthEstimatePairEvent;
	using TF = geometry_msgs::TransformStamped;
	using TransformPairEvent = GroundTruthEstimatePairEvent<TF, TF>;

	template <>
	class GroundTruthEstimatePairEvent<TF, TF> : public core::Event {
	public:
		EVENT_CLASS_TYPE(EventType::TransformPair)
		EVENT_CLASS_CATEGORY(EventCategoryDataTransfer)

		explicit GroundTruthEstimatePairEvent(std::pair<TF, TF> tf_pair)
			: pair_{std::move(tf_pair)} {}

		auto GetPair() const -> std::pair<TF, TF> { return pair_; }

	private:
		std::pair<TF, TF> pair_;
	};

} //namespace airsim_client
#endif //AIRSIM_CLIENT_ROS_EVENT
