
#ifndef AIRSIM_CLIENT_ODOMETRY_ERROR_NODE
#define AIRSIM_CLIENT_ODOMETRY_ERROR_NODE

#include "Core/Node.hpp"
#include "Events/AirSimEvent.hpp"
#include "Events/RosEvent.hpp"

#include <queue>

namespace airsim_client {

	class OdometryErrorNode : public core::Node {

	public:
		void OnStartup() override;
		void OnShutdown() override;
		void OnUpdate(Seconds dt) override;
		void OnEvent(core::Event& e) override;

		inline void SetEventCallbackFn(const EventCallbackFn& callback) override { EventCallback = callback; }

	private:
		bool OnTransformPairEvent(const TransformPairEvent& e);

		void UpdatePositionError();

	private:
		EventCallbackFn EventCallback;

		std::queue<std::pair<TF, TF>> tf_queue_;

		float tf_mse_ = 0;
		int num_measurements_ = 0;
	};


} // namespace airsim_client

#endif //AIRSIM_CLIENT_ERROR_NODE
