#include "Core/Client.hpp"
#include "AirSimTools/SettingsParser.hpp"
#include "Nodes/OdometryErrorNode.hpp"
#include "Nodes/Ros/RosNode.hpp"
#include "Nodes/AirSim/MultirotorNode.hpp"
#include "Nodes/AirSim/CvNode.hpp"

#include <memory>

int main(int argc, char** argv) {
	using namespace std::chrono_literals;

	auto client = std::make_unique<airsim_client::core::Client>();

	client->AddNode(std::make_unique<airsim_client::OdometryErrorNode>());
	client->AddNode(std::make_unique<airsim_client::RosNode>(argc, argv));
	
	airsim_client::SettingsParser::Get().SimMode() == "ComputerVision" ?
		client->AddNode(std::make_unique<airsim_client::CvNode>()) :
		client->AddNode(std::make_unique<airsim_client::MultirotorNode>(200ms));

	client->Run();
	return 0;
}
